﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace University_Code_Stage_I
{
    public class Program
    {
        public static void Main(string[] args)
        {
            // Hallgatók létrehozása
            Student student1 = new Student() { Name = "Gipsz Jakab" };
            Student student2 = new Student() { Name = "Teszt Elek" };

            Console.WriteLine("*** MAIN *** CREATED STUDENTS\n");

            // Tárgyak és követelmények létrehozása
            Midterm subject1Midterm1 = new Midterm() { Name = "Mid-term 1", IsRepeatable = true };
            Midterm subject1Midterm2 = new Midterm() { Name = "Mid-term 2", IsRepeatable = true };
            Subject subject1 = new Subject(
                "Subject 1",
                new List<Midterm>() { subject1Midterm1, subject1Midterm2 }
                );

            Midterm subject2Midterm1 = new Midterm() { Name = "Mid-term", IsRepeatable = false };
            Subject subject2 = new Subject(
                "Subject 2",
                new List<Midterm>() { subject2Midterm1 }
                );

            Console.WriteLine("*** MAIN *** CREATED SUBJECTS AND REQUIREMENTS\n");


            // Félévek létrehozása
            Semester semester1 = new Semester(
                    new List<Subject>() { subject1, subject2 }
                );

            Console.WriteLine("*** MAIN *** CREATED SEMESTERS\n");

            // A NEPTUN rendszer létrehozása
            NEPTUNSystem system = new NEPTUNSystem(
                    new List<Student>() { student1, student2 },
                    new List<Semester>() { semester1 }
                );

            Console.WriteLine("*** MAIN *** CREATED NEPTUN SYSTEM\n");

            // A félév menete
            student1.StartSemester(semester1);
            student2.StartSemester(semester1);
            Console.WriteLine("*** MAIN *** STARTED SEMESTERS\n");

            subject1.AddMidtermResult(student1, subject1Midterm1, true);
            subject1.AddMidtermResult(student1, subject1Midterm2, false);
            subject1.AddMidtermResult(student1, subject1Midterm2, true);
            subject1.AddExamResult(student1, true);
            Console.WriteLine("*** MAIN *** ADDED RESULTS FOR STUDENT 1\n");

            subject2.AddMidtermResult(student1, subject2Midterm1, false);
            Console.WriteLine("*** MAIN *** ADDED RESULTS FOR STUDENT 2\n");

            student1.EndSemester();
            student2.EndSemester();
            Console.WriteLine("*** MAIN *** ENDED SEMESTERS\n");
        }
    }
}
